/****************************************************************************
 * (c) 2019 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * PWM Ausgabe steuern
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <arduino.h>
#include <PWM.h>
#include "pwmctrl.h"

// Defines -------------------------------------------------------------------
//UNO PWM PINS : 3, 5, 6, 9, 10, 11
#define FREQOUTPIN 9

// Variablen -----------------------------------------------------------------
static long frq   = 0l;
static long width = 0l;

// interne Prototypen --------------------------------------------------------

// Funktionen ----------------------------------------------------------------
void pwm_Init(void)
{
  InitTimersSafe();

  //Voreinstellungen
  frq   = (long)1; //Hz
  width = (long)50; //%
  
  //Frequenz setzen
  SetPinFrequency(FREQOUTPIN, frq);
  
  //Pulsbreite setzen
  pwmWrite(FREQOUTPIN, 50 * 2.55f);
}

void pwm_SetzeFrequenz(long f)
{
  frq = f; 
  SetPinFrequency(FREQOUTPIN, frq);
  pwmWrite(FREQOUTPIN, width * 2.55f);
}

void pwm_SetzePulsBreite(long w)
{
  width = w;  
  pwmWrite(FREQOUTPIN, width * 2.55f);
}

int pwm_GetOutputPin(void)
{
  return(FREQOUTPIN);
}

long pwm_GetFrequenz(void)
{
  return(frq);
}

long pwm_GetPulsBreite(void)
{
  return(width);
}
