/****************************************************************************
 * (c) 2019 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * I2c Meldungen vom zu testenden System "Device under Test"
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <arduino.h>
#include <Wire.h>
#include "twictrl.h"

// Defines -------------------------------------------------------------------

// typedefs ------------------------------------------------------------------
enum aphor {gesperrt,frei};
enum txtstatus {neu, gelesen};

// Variablen -----------------------------------------------------------------
static char txt[TXTLEN];
static byte cnt = (byte)0;
static aphor sem = frei;
static txtstatus txtstat = neu;

// interne Prototypen --------------------------------------------------------
static void receiveEvent(int count);
static void cleartext(void);

// Funktionen ----------------------------------------------------------------
void twi_Init(void)
{
  Wire.begin(0x28);
  Wire.onReceive(receiveEvent);  
}

static void receiveEvent(int count)
{
  sem = gesperrt;
  cleartext();
  cnt = count; // Compiler Warnung entfernen
  cnt = (byte)0;
  Serial.print(F("DUT: "));
  while(0 < Wire.available())
  {
    txt[cnt] = Wire.read();
    Serial.print(txt[cnt]);
    cnt++;
  }
  Serial.println();
  txtstat = neu;
  sem     = frei;
}

bool twi_CheckMessage(void)
{
  bool retval = (bool)false;
  
  if ((frei == sem) && (cnt != (byte)0) && (neu == txtstat))
  {
    retval = (bool)true;
  }
  return(retval);
}

void twi_CopyMessage(char *text)
{
  int i = 0;

  for(i = 0; i < TXTLEN; i++)
  {
    text[i] = txt[i];
  }
  txtstat = gelesen;
}

// Textausgabefeld initialisieren
static void cleartext(void)
{
  int i = 0;

  for(i = 0; i < TXTLEN; i++)
  {
    txt[i] = ENDE;
  }
}
